<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

/* public */ class programLoader extends serializeableObject {

  /* private event */        var $event;
  /* private Hashtable */    var $config    = array(); # configuration
  /* private mode */         var $mode = 0;
  /* public pluginManager */ var $plugins;
  /* public dispatcher */    var $interface;
  /* public registry */      var $registry;
  /* public view */          var $view;

  /* constructor */ function programLoader(/* String */ $filename, /* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($filename, "string");
    settype($ARGS, "array");
    $event = strtolower($event);

    # Starting Boot-up sequence :

          # Prevent PHP from showing error messages to avoid information leak to hackers
          # error_reporting(0);
          # uncomment this for debug-mode :
          # error_reporting(E_ALL);


          # Check availability of source file
          if (!is_file($filename)) { $filename = "config/_loader.config"; }; clearstatcache();

          # 1. StartUp :                                   
          $this->config       = getConfigFile($filename,true);
          # 2. Load Plugins :
            $this->plugins      = new pluginManager($this->config['PLUGINDIR'],$this->config['PLUGINFILE']);
            $PLG_LIST = $this->plugins->getPluginList();
            settype($PLG_LIST, "array");
          # 3. Establish Interface :
            $this->interface    = new dispatcher($this->config['DISPATCHFILE']);
             # 3.1 Import plugin - interfaces :
            foreach ($PLG_LIST as $a => $b) {
             $b = $b['PLUGIN'];
             if ($b['ACTIVE']) {
             if (isset($b["INTERFACE"])) {
             settype($b["INTERFACE"], "array");
             foreach ($b["INTERFACE"] as $c => $d) {
             settype($d, "string");
             if (is_file($this->config['PLUGINDIR'].$b['ID']."/".$d)) $this->interface->addInterface($this->config['PLUGINDIR'].$b['ID']."/".$d);
             } # end for
             } # end if
             } # end if
            } # end for
          # 3. Build global Registry :
            # 3.a) get configuration mode
            $this->mode = $this->interface->get($event, "MODE");
            settype($this->mode, "integer");
            # 3.b) build configuration
            $REF = array();
            $REF = mergeArrays($this->config,$ARGS);
            if (count($REF) == 0) { $REF = array ("__PHP_PWD_DBASE__" => "74e12c1b837c67e7fa4f6a2eacd6076f"); }
          $this->registry     = new registry($this->config['CONFIGDRIVE'], $REF, "", $this->mode);
          $this->registry->read();
            # 3.c) Save Referer
            unset($Referer);
            if (function_exists('getallheaders') && $Referer = @getallheaders()) {
              if (!empty($Referer['Referer']) && $Referer['Referer']) $this->registry->setKey("REFERER", preg_replace("/(.*\/).*(\?.*)?/", "\\1", $Referer['Referer']));
              unset($Referer);
            }        

          # 4. Load Plugins :
              # 4.1) Load plugin - information files :
              foreach ($PLG_LIST as $a => $b) {
               $b = $b['PLUGIN'];
               if ($b['ACTIVE']) {
               # 4.1a) Import plugin - settings :
               if (isset($b['SETTINGS'])) {
               settype($b['SETTINGS'], "array");
               foreach ($b['SETTINGS'] as $c => $d) {
               settype($d, "string");
               if (is_file($this->config['PLUGINDIR'].$b['ID']."/".$d)) $this->registry->merge("", getConfigFile($this->config['PLUGINDIR'].$b['ID']."/".$d, true));
               } # end for
               } # end if
               } # end if
             } # end for
          # 5. prepare Template :
          $this->view = new view($this->getRegistryKey("SETTINGS"));
          $this->setEvent($event);
    # Ready to go ...

  }

  /* public boolean */ function handle(/* String */ $event,  /* Hashtable */ $ARGS) {
     $this->event = $event;
     if ($event=="test") selbstdiagnose($ARGS['target']);
     return $this->interface->notify($event,$ARGS);
  }

  /* public mixed */ function getRegistryKey(/* String */ $key) {
    return $this->registry->getKey($key);
  }

  /* public booolean */ function setRegistryKey(/* String */ $key, /* mixed */ $value) {
    return $this->registry->setKey($key, $value);
  }

  /* public booolean */ function unsetRegistryKey(/* String */ $key) {
    return $this->registry->unsetKey($key);
  }

  /* public boolean */ function refreshView() {
     $baseDoc    = $this->interface->get($this->event, "TEMPLATE");
     $includeDoc = $this->interface->get($this->event, "INSERT");
     return $this->updateView($baseDoc,$includeDoc);
  }

  /* public void */ function meldung(/* String */ $level, /* String */ $errcode, /* String */ $event = "") {
    settype($level, "string");
    settype($errcode, "string");
    settype($event, "string");
    $errcode = strtoupper($errcode);

    $this->view->meldung($level, $errcode, $event);
  }
  
  /* public boolean */ function updateView(/* String */ $baseDoc, /* String */ $includeDoc) {
    settype($baseDoc, "string");
    settype($includeDoc, "string");
    switch ($baseDoc) {
                      	
      case "NULL":
        $this->view->unsetView();
        return true;
      break;
      
      case "MESSAGE":
        return true;
      break;

      case "":
        return true;
      break;
      
      default:
        if ($baseDoc)    $this->view->selectBaseView($baseDoc);
        if ($includeDoc) $this->view->selectView($includeDoc);
      break;

    } # end switch
  }
  
  /* public void */ function writeView() {
    $this->refreshView();
    $this->view->buildPage();
    $this->registry->mount("language_stdout_file");
    $this->view->setOptions("*");
    $this->view->show();
  }
  
  /* public int */ function getMode() {
    return $this->mode;                                  	
  }
  
  /* public String */ function getEvent() {
    return $this->event;
  }

  /* public boolean */ function setEvent(/* String */ $event) {
    $this->setRegistryKey("ACTION", $event);
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

}
                                         
define("ProgramInstanceId", md5(getcwd().$REMOTE_ADDR));

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
